
		.title	CHKEXEC v0.10 (C)1995 Tachibana Eririn

program:	.reg	'CHKEXEC'
version:	.reg	'v0.10'
copyright:	.reg	'(C)1995 Tachibana Eririn'

_TITLE:		.reg	program,SPC,version,SPC,copyright,LF


* Include File -------------------------------- *

		.include	eririn.mac
		.include	doscall.mac


* Global Symbol ------------------------------- *

		.xref	keepchk


* Offset Table Section ------------------------ *

		.offset	0
exec_md:	.ds	1
exec_file:
exec_address:	.ds.l	1
exec_cmdline:
exec_buffer:
exec_load:
exec_target:	.ds.l	1
exec_env:
exec_limit:	.ds.l	1
exec_env2:	.ds.l	1


		.offset	0
		.dc.b	_TITLE,0
titlelen:
filename_buf:	.equ	__title+titlelen


* Macro --------------------------------------- *

_B_PUTC:	.equ	$20

IOCS_:		.macro	callno
		movea.l	(callno*4+$400),a0
		jsr	(a0)
		.endm

DOS_:		.macro	callno
		lea	(sp),a6
		movea.l	(.low.callno*4+$1800),a0
		jsr	(a0)
		.endm

PUSH_A6:	.macro
		move.l	a6,-(sp)		* DOS_ OɎs
		.endm
POP_A6:		.macro
		movea.l	(sp)+,a6		* DOS_ Ɏs
		.endm

* Text Section -------------------------------- *


_IGNORE_NUL_ARG:
		.include	startup.s


* 풓 vO --------------------------- *

usereg:		.reg	d0-d7/a0-a6

		.text
		.quad
filename_bufend:

old_vec:	.dc.l	0
fileno:		.dc	0

new_dos_exec:
		PUSH	usereg
		bsr	open_logfile
		bne	open_logfile_error

		move.l	(exec_md,a6),d0		* module+mode \
		lea	(md_mes,pc),a1
		lea	(7,a1),a0
		moveq	#4-1,d1
		bsr	print_hex_loop

		move	(exec_md,a6),d1
		andi	#$00ff,d1
		cmpi	#5,d1
		bhi	unknown_mode		* mode>=6Ȃ烂[hƕԒl\

		add	d1,d1
		move	d1,-(sp)
		lea	(md_mes_table,pc,d1.w),a1
		adda	(a1),a1
		bsr	print_str

		move	(sp)+,d1
		move	(md_table,pc,d1.w),d1
		jmp	(md_table,pc,d1.w)

md_mes_table:
		.irpc	%MD,012345
		.dc	md_mes_%MD-$
		.endm
md_table:
		.irpc	%MD,012345
		.dc	md_%MD-md_table
		.endm

md_0:
md_1:
		bsr	print_file

		lea	(cmdline_mes,pc),a1
		lea	(12,a1),a0
		move.l	(exec_cmdline,a6),d0
		bsr	print_hex
		movea.l	(exec_cmdline,a6),a1
		addq.l	#1,a1		* 񒷂΂
		bsr	print_str

		bra	print_env_ret

md_2:
		bsr	print_file

		lea	(buffer_mes,pc),a1
		lea	(11,a1),a0
		move.l	(exec_buffer,a6),d0
		bsr	print_hex

		bra	print_env_ret

md_3:
		bsr	print_file

		lea	(load_mes,pc),a1
		lea	(8,a1),a0
		move.l	(exec_load,a6),d0
		bsr	print_hex

		lea	(limit_mes,pc),a1
		lea	(9,a1),a0
		move.l	(exec_limit,a6),d0
		bsr	print_hex

		move.l	(exec_env2,a6),d0
		bra	print_env2_ret

md_4:
		lea	(address_mes,pc),a1
		lea	(12,a1),a0
		move.l	(exec_address,a6),d0
		bra	print_hex_ret

md_5:
		bsr	print_file

		lea	(target_mes,pc),a1
		lea	(10,a1),a0
		move.l	(exec_target,a6),d0
		bsr	print_hex
		movea.l	(exec_target,a6),a1
		bsr	print_str
unknown_mode:
		lea	(newline,pc),a1
		bsr	print_str
		bra	print_return_value

print_env_ret:
		move.l	(exec_env,a6),d0
print_env2_ret:
		lea	(env_mes,pc),a1
		lea	(8,a1),a0
print_hex_ret:
		bsr	print_hex
print_return_value:
		POP	usereg
		bsr	call_dos_exec_orig
		PUSH	usereg

		lea	(ret_mes,pc),a1
		lea	(7,a1),a0
		bsr	print_hex

		bsr	close_logfile
		POP	usereg
		rts

open_logfile_error:
		bsr	close_logfile
		POP	usereg
call_dos_exec_orig:
		move.l	(old_vec,pc),-(sp)
		rts

print_file:
		lea	(file_mes,pc),a1
		lea	(9,a1),a0
		move.l	(exec_file,a6),d0
		bsr	print_hex
		movea.l	(exec_file,a6),a1
		bra	print_str

hextable:	.dc.b	'0123456789abcdef'

print_hex:
		moveq	#8-1,d1
print_hex_loop:
		rol.l	#4,d0
		moveq	#$f,d2
		and	d0,d2
		move.b	(hextable,pc,d2.w),(a0)+
		dbra	d1,print_hex_loop
		bra	print_str

print_str:
		move.b	(filename_buf,pc),d0
		beq	print_str_console

		PUSH_A6
		move	(fileno,pc),-(sp)
		move.l	a1,-(sp)
		DOS_	_FPUTS
		addq.l	#6,sp
		POP_A6
@@:
		rts
print_str_console:
		moveq	#0,d1
		move.b	(a1)+,d1
		beq	@b
print_str_loop:
		cmpi	#LF,d1
		bne	@f
		moveq	#CR,d1
		IOCS_	_B_PUTC
		moveq	#LF,d1
@@:
		IOCS_	_B_PUTC
		moveq	#0,d1
		move.b	(a1)+,d1
		bne	print_str_loop
		rts

open_logfile:
		lea	(filename_buf,pc),a1
		tst.b	(a1)
		beq	open_logfile_ok

		PUSH_A6
		move	#WOPEN,-(sp)
		move.l	a1,-(sp)
		DOS_	_OPEN
		addq.l	#6,sp
		POP_A6
		lea	(fileno,pc),a1
		move	d0,(a1)
		bmi	@f

		PUSH_A6
		move	#SEEK_END,-(sp)
		clr.l	-(sp)
		move	d0,-(sp)
		DOS_	_SEEK
		addq.l	#8,sp
		POP_A6
		tst.l	d0
		bmi	@f
open_logfile_ok:
		moveq	#0,d0
@@:
		rts

close_logfile:
		move.b	(filename_buf,pc),d0
		beq	close_logfile_ok

		PUSH_A6
		move	(fileno,pc),-(sp)
		bmi	@f
		DOS_	_CLOSE
@@:
		addq.l	#2,sp
		POP_A6
close_logfile_ok:
		rts


* 풓 f[^ ------------------------------- *

*		.data

md_mes:		.dc.b	LF,'MD	= $0000',0

md_mes_0:	.dc.b	'(loadexec)',0
md_mes_1:	.dc.b	'(load)',0
md_mes_2:	.dc.b	'(pathchk)',0
md_mes_3:	.dc.b	'(loadonly)',0
md_mes_4:	.dc.b	'(execonly)',0
md_mes_5:	.dc.b	'(bindno)',0

file_mes:	.dc.b	LF,'FILE	= $00000000 : ',0

cmdline_mes:	.dc.b	LF,'CMDLINE	= $00000000 : ',0

env_mes:	.dc.b	LF, 'ENV	= $00000000',LF,0

buffer_mes:	.dc.b	LF,'BUFFER	= $00000000',0

load_mes:	.dc.b	   'LOAD	= $00000000',LF,0
limit_mes:	.dc.b	   'LIMIT	= $00000000',LF,0

address_mes:	.dc.b	LF,'ADDRESS	= $00000000',LF,0

target_mes:	.dc.b	   'TARGET	= $00000000 : ',0

ret_mes:	.dc.b	    'RET	= $00000000'
newline:	.dc.b	LF,0

		.even
keep_size:	.equ	$-__main

*		.text


* 풓 ------------------------------------ *

_main:
		moveq	#0,d6			* 0=t@Cw 1=w肠 -1=-r
		lea	(filename_buf,pc),a1
		move.b	d6,(a1)
get_argument_next:
		dbra	d7,argument_loop

		lea	(__main-$100,pc),a0
		lea	(__title,pc),a1
		bsr	keepchk
		tst	d6
		bmi	release

		tst.l	d0
		beq	already_keeped

* logfile I[v
		tst	d6
		beq	opentest_skip		* consoleɏo

		move	#ARCHIVE,-(sp)
		pea	(filename_buf,pc)
		DOS	_NEWFILE		* VK쐬
		tst.l	d0
		bpl	opentest_ok

		move	#WOPEN,(4,sp)
		DOS	_OPEN			* ɑ݂ꍇ͏݃I[v
		tst.l	d0
		bpl	opentest_ok

		pea	(fopen_error_mes,pc)
		bra	print_exit_error

opentest_ok:
		addq.l	#6,sp
		DOS	_ALLCLOSE
opentest_skip:
		pea	(new_dos_exec,pc)
		move	#_EXEC,-(sp)
		DOS	_INTVCS
		addq.l	#6,sp

		lea	(old_vec,pc),a1
		move.l	d0,(a1)

		bsr	print_progname
		pea	(keep_mes,pc)
		DOS	_PRINT

		clr	-(sp)
		pea	(keep_size).w
		DOS	_KEEPPR

already_keeped:
		bsr	print_progname
		pea	(already_keeped_mes,pc)
		bra	print_exit_error

release:
		tst.l	d0
		bmi	not_keeped

		pea	(16,a0)			* DOS _MFREE p
		lea	($100,a0),a0		* = __main

		move.l	(old_vec-__main,a0),-(sp)
		move	#_EXEC,-(sp)
		DOS	_INTVCG

		lea	(new_dos_exec-__main,a0),a1
		cmp.l	a1,d0
		bne	overhooked

		DOS	_INTVCS
		addq.l	#6,sp

*		move.l	a0,-(sp)
		DOS	_MFREE

		bsr	print_progname
		pea	(released_mes,pc)
		DOS	_PRINT
		DOS	_EXIT

overhooked:
		bsr	print_progname
		pea	(overhooked_mes,pc)
		bra	print_exit_error
not_keeped:
		bsr	print_progname
		pea	(not_keeped_mes,pc)
		bra	print_exit_error

argument_loop:
		move.b	(a0)+,d1

		cmpi.b	#'-',d1
		beq	check_option

		tst	d6
		bne	print_usage
		moveq	#1,d6			* t@Cw肠

		subq.l	#1,a0
*		lea	(filename_buf,pc),a1
		moveq	#filename_bufend-filename_buf-1,d0
@@:
		move.b	(a0)+,(a1)+
		dbeq	d0,@b
		beq	get_argument_next

		bsr	print_progname
		pea	(too_long_mes,pc)
		bra	print_exit_error

check_option:
		moveq	#-1,d6			* -r

		move.b	(a0)+,d1
		beq	print_usage
		ori.b	#$20,d1
		cmpi.b	#'v',d1
		beq	print_proginfo

		tst.b	(a0)+
		bne	print_usage
		cmpi.b	#'r',d1
		beq	get_argument_next
print_usage:
		bsr	print_title
		pea	(usage_mes,pc)
print_exit_error:
		DOS	_PRINT
		move	#EXIT_FAILURE,(sp)
		DOS	_EXIT

print_proginfo:
		bsr	print_title
		DOS	_EXIT


print_progname:
		pea	(progname,pc)
		bra	@f
print_title:
		pea	(__title,pc)
@@:
		DOS	_PRINT
		addq.l	#4,sp
		rts


* Data Section -------------------------------- *

		.data
usage_mes:
		.dc.b	'usage: checkexec [-r] [logfile]',CR,LF,0
progname:
		.dc.b	'checkexec: ',0
too_long_mes:
		.dc.b	't@C܂.',CR,LF,0

keep_mes:
		.dc.b	'풓܂.',CR,LF,0
already_keeped_mes
		.dc.b	'ɏ풓Ă܂.',CR,LF,0

released_mes:
		.dc.b	'풓܂.',CR,LF,0
overhooked_mes:
		.dc.b	'xN^Ă܂.',CR,LF,0
not_keeped_mes:
		.dc.b	'풓Ă܂.',CR,LF,0

fopen_error_mes:
		.dc.b	'Ot@CI[vo܂.',CR,LF,0


* End of Source ------------------------------- *

		.end	__main

MD	= 0,1
FILE	= $???????? : foo.x
CMDLINE	= $???????? : $??,bar
ENV	= $????????
RET	= $????????

MD	= 2
FILE	= $???????? : foo.x
BUFFER	= $????????
ENV	= $????????
RET	= $????????

MD	= 3
FILE	= $???????? : foo.x
LOAD	= $????????
LIMIT	= $????????
ENV	= $????????
RET	= $????????

MD	= 4
ADDRESS	= $????????
RET	= $????????

MD	= 5
FILE	= $???????? : foo.x
TARGET	= $???????? : bar.x
RET	= $????????
